/**
 * @license
 * Copyright 2020 Google LLC. All Rights Reserved.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * =============================================================================
 */
!function(t,e){"object"==typeof exports&&"undefined"!=typeof module?e(exports,require("@tensorflow/tfjs-core"),require("seedrandom")):"function"==typeof define&&define.amd?define(["exports","@tensorflow/tfjs-core","seedrandom"],e):e((t=t||self).tf=t.tf||{},t.tf,t.seedrandom)}(this,(function(t,e,r){"use strict";function a(t,r,a,n){for(var o=e.util.getTypedArrayFromDType(n,e.util.sizeFromShape(a)),i=0;i<o.length;++i){for(var s=i*r,d=t[s],p=0;p<r;++p){var u=t[s+p];u>d&&(d=u)}o[i]=d}return o}function n(t,r,a,n,o){for(var i=r.length,s=e.util.sizeFromShape(r),d=e.util.computeStrides(r),p=e.util.computeStrides(o),u=e.util.getTypedArrayFromDType(a,e.util.sizeFromShape(o)),h=0;h<s;++h){for(var f=e.util.indexToLoc(h,i,d),l=new Array(f.length),c=0;c<l.length;c++)l[c]=f[n[c]];u[e.util.locToIndex(l,i,p)]=t[h]}return u}var o={__proto__:null,maxImpl:a,transposeImpl:n},i=function(t,e){return(i=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var r in e)e.hasOwnProperty(r)&&(t[r]=e[r])})(t,e)};function s(t,e,r,a){return new(r||(r=Promise))((function(n,o){function i(t){try{d(a.next(t))}catch(t){o(t)}}function s(t){try{d(a.throw(t))}catch(t){o(t)}}function d(t){var e;t.done?n(t.value):(e=t.value,e instanceof r?e:new r((function(t){t(e)}))).then(i,s)}d((a=a.apply(t,e||[])).next())}))}function d(t,e){var r,a,n,o,i={label:0,sent:function(){if(1&n[0])throw n[1];return n[1]},trys:[],ops:[]};return o={next:s(0),throw:s(1),return:s(2)},"function"==typeof Symbol&&(o[Symbol.iterator]=function(){return this}),o;function s(o){return function(s){return function(o){if(r)throw new TypeError("Generator is already executing.");for(;i;)try{if(r=1,a&&(n=2&o[0]?a.return:o[0]?a.throw||((n=a.return)&&n.call(a),0):a.next)&&!(n=n.call(a,o[1])).done)return n;switch(a=0,n&&(o=[2&o[0],n.value]),o[0]){case 0:case 1:n=o;break;case 4:return i.label++,{value:o[1],done:!1};case 5:i.label++,a=o[1],o=[0];continue;case 7:o=i.ops.pop(),i.trys.pop();continue;default:if(!(n=i.trys,(n=n.length>0&&n[n.length-1])||6!==o[0]&&2!==o[0])){i=0;continue}if(3===o[0]&&(!n||o[1]>n[0]&&o[1]<n[3])){i.label=o[1];break}if(6===o[0]&&i.label<n[1]){i.label=n[1],n=o;break}if(n&&i.label<n[2]){i.label=n[2],i.ops.push(o);break}n[2]&&i.ops.pop(),i.trys.pop();continue}o=e.call(t,i)}catch(t){o=[6,t],a=0}finally{r=n=0}if(5&o[0])throw o[1];return{value:o[0]?o[1]:void 0,done:!0}}([o,s])}}}function p(t,r){Array.isArray(t)||(t=[t]),t.forEach((function(t){null!=t&&e.util.assert("complex64"!==t.dtype,(function(){return r+" does not support complex64 tensors in the CPU backend."}))}))}function u(t,r,a,n,o,i){for(var s=o.strideHeight,d=o.strideWidth,p=o.dilationHeight,u=o.dilationWidth,h=o.effectiveFilterHeight,f=o.effectiveFilterWidth,l=o.padInfo.top,c=o.padInfo.left,v="max"===i?Number.NEGATIVE_INFINITY:Number.POSITIVE_INFINITY,y=e.buffer(o.outShape,a),m=y.values,g=o.outShape[1]*o.outShape[2]*o.outShape[3],S=o.outShape[2]*o.outShape[3],I=o.outShape[3],b=0;b<o.batchSize;++b)for(var k=b*g,M=b*n[0],x=0;x<o.inChannels;++x)for(var A=0;A<o.outHeight;++A)for(var F=A*s-l,D=Math.max(0,F),w=Math.min(o.inHeight,h+F),T=k+A*S,N=0;N<o.outWidth;++N){for(var z=N*d-c,W=Math.max(0,z),_=Math.min(o.inWidth,f+z),H=v,O=0,C=0,B=D;B<w;B+=p){for(var E=M+B*n[1],P=W;P<_;P+=u){var R=t[E+P*n[2]+x];"max"===i&&R>H?H=R:"avg"===i&&(O+=R,C++)}if(isNaN(H))break}m[T+N*I+x]="avg"===i?O/C:H}return y}function h(t,r,a,n,o,i){void 0===o&&(o=!1),void 0===i&&(i=!1);for(var s=e.buffer(n.outShape,"int32"),d=n.strideHeight,p=n.strideWidth,u=n.dilationHeight,h=n.dilationWidth,f=n.effectiveFilterHeight,l=n.effectiveFilterWidth,c=n.padInfo.top,v=n.padInfo.left,y=e.buffer(r,a,t),m=0;m<n.batchSize;++m)for(var g=0;g<n.inChannels;++g)for(var S=0;S<n.outHeight;++S){for(var I=S*d-c,b=I;b<0;)b+=u;for(var k=Math.min(n.inHeight,f+I),M=0;M<n.outWidth;++M){for(var x=M*p-v,A=x;A<0;)A+=h;for(var F=Math.min(n.inWidth,l+x),D=Number.NEGATIVE_INFINITY,w=-1,T=b;T<k;T+=u)for(var N=T-I,z=A;z<F;z+=h){var W=z-x,_=y.get(m,T,z,g);_>D&&(D=_,w=o?i?((m*n.inHeight+T)*n.inWidth+z)*n.inChannels+g:(T*n.inWidth+z)*n.inChannels+g:N*l+W)}s.set(w,m,S,M,g)}}return s}var f=e.kernel_impls.nonMaxSuppressionV3Impl,l=e.kernel_impls.split,c=e.kernel_impls.tile,v=e.kernel_impls.topkImpl,y=e.kernel_impls.whereImpl;function m(t,e,r,a){if("linear"===r)return t.linear(e);if("relu"===r)return t.relu(e);if("elu"===r)return t.elu(e);if("relu6"===r)return t.relu6(e);if("prelu"===r)return t.prelu(e,a);throw new Error("Activation "+r+" has not been implemented for the CPU backend.")}var g=function(t){function a(){var r=t.call(this)||this;return r.blockSize=48,r.firstUse=!0,r.data=new e.DataStorage(r,e.engine()),r}return function(t,e){function r(){this.constructor=t}i(t,e),t.prototype=null===e?Object.create(e):(r.prototype=e.prototype,new r)}(a,t),a.prototype.write=function(t,r,a){this.firstUse&&(this.firstUse=!1,e.env().get("IS_NODE")&&e.backend_util.warn("\n============================\nHi there 👋. Looks like you are running TensorFlow.js in Node.js. To speed things up dramatically, install our node backend, which binds to TensorFlow C++, by running npm i @tensorflow/tfjs-node, or npm i @tensorflow/tfjs-node-gpu if you have CUDA. Then call require('@tensorflow/tfjs-node'); (-gpu suffix for CUDA) at the start of your program. Visit https://github.com/tensorflow/tfjs-node for more details.\n============================"));var n={};return this.data.set(n,{values:t,dtype:a}),n},a.prototype.move=function(t,e,r,a){this.data.set(t,{values:e,dtype:a})},a.prototype.numDataIds=function(){return this.data.numDataIds()},a.prototype.read=function(t){return s(this,void 0,void 0,(function(){return d(this,(function(e){return[2,this.readSync(t)]}))}))},a.prototype.readSync=function(t){var r=this.data.get(t),a=r.dtype,n=r.complexTensors;if("complex64"===a){var o=this.readSync(n.real.dataId),i=this.readSync(n.imag.dataId);return e.backend_util.mergeRealAndImagArrays(o,i)}return this.data.get(t).values},a.prototype.bufferSync=function(t){var r=this.readSync(t.dataId),a=r;if("string"===t.dtype)try{a=r.map((function(t){return e.util.decodeString(t)}))}catch(t){throw new Error("Failed to decode encoded string bytes into utf-8")}return e.buffer(t.shape,t.dtype,a)},a.prototype.makeOutput=function(t,r,a){var n=this.write(t,r,a);return e.engine().makeTensorFromDataId(n,r,a,this)},a.prototype.disposeData=function(t){if(this.data.has(t)){var e=this.data.get(t).complexTensors;null!=e&&(e.real.dispose(),e.imag.dispose()),this.data.delete(t)}},a.prototype.time=function(t){return s(this,void 0,void 0,(function(){var r;return d(this,(function(a){return r=e.util.now(),t(),[2,{kernelMs:e.util.now()-r}]}))}))},a.prototype.memory=function(){return{unreliable:!0,reasons:["The reported memory is an upper bound. Due to automatic garbage collection, the true allocated memory may be less."]}},a.prototype.complex=function(t,r){var a=this.makeOutput(null,t.shape,"complex64");return this.data.get(a.dataId).complexTensors={real:e.engine().keep(t.clone()),imag:e.engine().keep(r.clone())},a},a.prototype.real=function(t){return this.data.get(t.dataId).complexTensors.real.clone()},a.prototype.imag=function(t){return this.data.get(t.dataId).complexTensors.imag.clone()},a.prototype.slice=function(t,r,a){if(p(t,"slice"),e.slice_util.isSliceContinous(t.shape,r,a)){var n=e.slice_util.computeFlatOffset(r,t.strides),o=e.util.sizeFromShape(a),i=this.readSync(t.dataId);return e.tensor(i.subarray(n,n+o),a,t.dtype)}for(var s=e.buffer(a,t.dtype),d=this.bufferSync(t),u=0;u<s.size;++u){var h=s.indexToLoc(u).map((function(t,e){return t+r[e]}));s.values[u]=d.get.apply(d,h)}return s.toTensor()},a.prototype.stridedSlice=function(t,r,a,n){p(t,"stridedSlice");var o=e.slice_util.computeOutShape(r,a,n);if(o.some((function(t){return 0===t})))return e.tensor([],o);for(var i=e.buffer(o,t.dtype),s=this.bufferSync(t),d=0;d<i.size;d++){for(var u=i.indexToLoc(d),h=new Array(u.length),f=0;f<h.length;f++)h[f]=u[f]*n[f]+r[f];i.set.apply(i,[s.get.apply(s,h)].concat(u))}return i.toTensor()},a.prototype.diag=function(t){for(var r=this.readSync(t.dataId),a=e.buffer([t.size,t.size],t.dtype),n=a.values,o=0;o<r.length;o++)n[o*t.size+o]=r[o];return a.toTensor()},a.prototype.unstack=function(t,e){for(var r=t.shape[e],a=new Array(t.rank-1),n=0,o=0;o<t.rank;o++)o!==e&&(a[n++]=t.shape[o]);var i=new Array(t.rank).fill(0),s=t.shape.slice();s[e]=1;var d=new Array(r);for(o=0;o<d.length;o++)i[e]=o,d[o]=this.slice(t,i,s).reshape(a);return d},a.prototype.reverse=function(t,r){p(t,"reverse");for(var a=e.buffer(t.shape,t.dtype),n=this.bufferSync(t),o=function(e){var o=a.indexToLoc(e),i=o.slice();r.forEach((function(e){return i[e]=t.shape[e]-1-i[e]})),a.set.apply(a,[n.get.apply(n,i)].concat(o))},i=0;i<a.size;i++)o(i);return a.toTensor()},a.prototype.concat=function(t,r){var a=this;if("complex64"===t[0].dtype){var n=t.map((function(t){return e.real(t)})),o=t.map((function(t){return e.imag(t)}));return e.complex(this.concat(n,r),this.concat(o,r))}var i=t.map((function(t){var a=e.util.sizeFromShape(t.shape.slice(r));return t.as2D(-1,a)})),s=e.backend_util.computeOutShape(i.map((function(t){return t.shape})),1),d=e.buffer(s,t[0].dtype).values;if(1===i[0].shape[0]){var p=0;i.forEach((function(t){d.set(a.readSync(t.dataId),p),p+=t.size}))}else{var u=0;i.forEach((function(t){for(var e=a.readSync(t.dataId),r=0,n=0;n<t.shape[0];++n)for(var o=n*s[1]+u,i=0;i<t.shape[1];++i)d[o+i]=e[r++];u+=t.shape[1]}))}var h=e.backend_util.computeOutShape(t.map((function(t){return t.shape})),r);return e.tensor(d,h,t[0].dtype)},a.prototype.neg=function(t){return p(t,"neg"),this.multiply(e.scalar(-1),t)},a.prototype.add=function(t,r){return"complex64"===t.dtype||"complex64"===r.dtype?this.broadcastedBinaryComplexOp(t.cast("complex64"),r.cast("complex64"),(function(t,e,r,a){return{real:t+r,imag:e+a}})):this.broadcastedBinaryOp(t,r,e.upcastType(t.dtype,r.dtype),(function(t,e){return t+e}))},a.prototype.addN=function(t){var r=this;p(t,"addN");for(var a=t.map((function(t){return r.readSync(t.dataId)})),n=e.buffer(t[0].shape,t[0].dtype),o=n.values,i=0;i<t.length;i++)for(var s=a[i],d=0;d<o.length;d++)o[d]+=s[d];return n.toTensor()},a.prototype.softmax=function(t,r){var a=e.util.parseAxisParam([r],t.shape),n=e.max(t,a),o=e.backend_util.expandShapeToKeepDim(n.shape,a),i=this.subtract(t,n.reshape(o)),s=this.exp(i),d=this.sum(s,a).reshape(o);return e.div(s,d)},a.prototype.subtract=function(t,r){return"complex64"===t.dtype||"complex64"===r.dtype?this.broadcastedBinaryComplexOp(t.cast("complex64"),r.cast("complex64"),(function(t,e,r,a){return{real:t-r,imag:e-a}})):this.broadcastedBinaryOp(t,r,e.upcastType(t.dtype,r.dtype),(function(t,e){return t-e}))},a.prototype.pow=function(t,e){return p([t,e],"pow"),this.broadcastedBinaryOp(t,e,t.dtype,(function(t,e){return Math.pow(t,e)}))},a.prototype.batchMatMul=function(t,r,a,n){p([t,r],"matMul");for(var o=a?t.shape[1]:t.shape[2],i=a?t.shape[2]:t.shape[1],s=n?r.shape[1]:r.shape[2],d=t.shape[0],u=this.readSync(t.dataId),h=this.readSync(r.dataId),f=a?[t.strides[0],1,t.strides[1]]:[t.strides[0],t.strides[1],1],l=f[0],c=f[1],v=f[2],y=n?[1,r.strides[1],r.strides[0]]:[r.strides[1],1,r.strides[0]],m=y[0],g=y[1],S=y[2],I=i*s,b=e.buffer([d,i,s],t.dtype),k=b.values,M=this.blockSize,x=0;x<d;x++)for(var A=0;A<i;A+=M)for(var F=0;F<s;F+=M)for(var D=0;D<o;D+=M)for(var w=Math.min(A+M,i),T=Math.min(F+M,s),N=Math.min(D+M,o),z=A;z<w;z++)for(var W=F;W<T;W++){for(var _=0,H=D;H<N;H++)_+=u[x*l+z*c+H*v]*h[H*m+W*g+x*S];k[x*I+(z*s+W)]+=_}return b.toTensor()},a.prototype.fusedBatchMatMul=function(t){var e=t.a,r=t.b,a=t.transposeA,n=t.transposeB,o=t.bias,i=t.activation,s=t.preluActivationWeights,d=this.batchMatMul(e,r,a,n);return o&&(d=this.add(d,o)),i&&(d=m(this,d,i,s)),d},a.prototype.multiply=function(t,r){return"complex64"===t.dtype||"complex64"===r.dtype?this.broadcastedBinaryComplexOp(t.cast("complex64"),r.cast("complex64"),(function(t,e,r,a){return{real:t*r-e*a,imag:t*a+e*r}})):this.broadcastedBinaryOp(t,r,e.upcastType(t.dtype,r.dtype),(function(t,e){return t*e}))},a.prototype.floorDiv=function(t,e){p([t,e],"floorDiv");return this.broadcastedBinaryOp(t,e,"int32",(function(t,e){return Math.floor(t/e)}))},a.prototype.sum=function(t,r){p(t,"sum"),e.backend_util.assertAxesAreInnerMostDims("sum",r,t.rank);for(var a=e.backend_util.computeOutAndReduceShapes(t.shape,r),n=a[0],o=a[1],i=e.upcastType(t.dtype,"int32"),s=e.zeros(n,i),d=e.util.sizeFromShape(o),u=this.readSync(s.dataId),h=this.readSync(t.dataId),f=0;f<u.length;++f){for(var l=f*d,c=0,v=0;v<d;++v)c+=h[l+v];u[f]=c}return s},a.prototype.prod=function(t,r){p(t,"sum");for(var a=e.backend_util.computeOutAndReduceShapes(t.shape,r),n=a[0],o=a[1],i=e.upcastType(t.dtype,"int32"),s=e.zeros(n,i),d=e.util.sizeFromShape(o),u=this.readSync(s.dataId),h=this.readSync(t.dataId),f=0;f<u.length;++f){for(var l=f*d,c=1,v=0;v<d;++v)c*=h[l+v];u[f]=c}return s},a.prototype.unsortedSegmentSum=function(t,r,a){p(t,"unsortedSegmentSum");for(var n=[],o=t.rank-r.rank,i=0;i<o;++i)r=r.expandDims(i+1);for(i=0;i<a;++i){var s=e.scalar(i,"int32"),d=e.equal(s,r).asType("float32").mul(t).sum(0);n.push(d)}return e.stack(n)},a.prototype.argMin=function(t,r){p(t,"argMin");var a=[r];e.backend_util.assertAxesAreInnerMostDims("argMin",a,t.rank);for(var n=e.backend_util.computeOutAndReduceShapes(t.shape,a),o=n[0],i=n[1],s=e.zeros(o,"int32"),d=e.util.sizeFromShape(i),u=this.readSync(s.dataId),h=this.readSync(t.dataId),f=0;f<u.length;++f){for(var l=f*d,c=h[l],v=0,y=0;y<d;++y){var m=h[l+y];m<c&&(c=m,v=y)}u[f]=v}return s},a.prototype.argMax=function(t,r){p(t,"argMax");var a=[r];e.backend_util.assertAxesAreInnerMostDims("argMax",a,t.rank);for(var n=e.backend_util.computeOutAndReduceShapes(t.shape,a),o=n[0],i=n[1],s=e.zeros(o,"int32"),d=e.util.sizeFromShape(i),u=this.readSync(s.dataId),h=this.readSync(t.dataId),f=0;f<u.length;++f){for(var l=f*d,c=h[l],v=0,y=0;y<d;++y){var m=h[l+y];m>c&&(c=m,v=y)}u[f]=v}return s},a.prototype.cumsum=function(t,r,a,n){if(p(t,"cumsum"),r!==t.rank-1)throw new Error("backend.cumsum in CPU expects an inner-most axis="+(t.rank-1)+" but got axis="+r);for(var o=e.upcastType(t.dtype,"int32"),i=e.zeros(t.shape,o),s=this.readSync(i.dataId),d=this.readSync(t.dataId),u=t.shape[t.rank-1],h=n?function(t,e){return t+u-e-1}:function(t,e){return t+e},f=0;f<d.length;f+=u)for(var l=0;l<u;l++){var c=h(f,l);if(0===l)s[c]=a?0:d[c];else{var v=h(f,l-1);s[c]=a?d[v]+s[v]:d[c]+s[v]}}return i},a.prototype.equal=function(t,e){return p([t,e],"equal"),this.broadcastedBinaryOp(t,e,"bool",(function(t,e){return t===e?1:0}))},a.prototype.notEqual=function(t,e){return p([t,e],"notEqual"),this.broadcastedBinaryOp(t,e,"bool",(function(t,e){return t!==e?1:0}))},a.prototype.less=function(t,e){return p([t,e],"less"),this.broadcastedBinaryOp(t,e,"bool",(function(t,e){return t<e?1:0}))},a.prototype.lessEqual=function(t,e){return p([t,e],"lessEqual"),this.broadcastedBinaryOp(t,e,"bool",(function(t,e){return t<=e?1:0}))},a.prototype.greater=function(t,e){return p([t,e],"greater"),this.broadcastedBinaryOp(t,e,"bool",(function(t,e){return t>e?1:0}))},a.prototype.greaterEqual=function(t,e){return p([t,e],"greaterEqual"),this.broadcastedBinaryOp(t,e,"bool",(function(t,e){return t>=e?1:0}))},a.prototype.logicalNot=function(t){p(t,"logicalNot");for(var e=this.readSync(t.dataId),r=new Uint8Array(e.length),a=0;a<e.length;++a)r[a]=e[a]?0:1;return this.makeOutput(r,t.shape,"bool")},a.prototype.logicalAnd=function(t,e){return p([t,e],"logicalAnd"),this.broadcastedBinaryOp(t,e,"bool",(function(t,e){return t&&e}))},a.prototype.logicalOr=function(t,e){return p([t,e],"logicalOr"),this.broadcastedBinaryOp(t,e,"bool",(function(t,e){return t||e}))},a.prototype.select=function(t,r,a){p([t,r,a],"select");for(var n=this.readSync(t.dataId),o=this.readSync(r.dataId),i=this.readSync(a.dataId),s=e.zeros(r.shape,e.upcastType(r.dtype,a.dtype)),d=this.readSync(s.dataId),u=0,h=0===t.rank||t.rank>1||1===r.rank?1:e.util.sizeFromShape(r.shape.slice(1)),f=0;f<n.length;f++)for(var l=0;l<h;l++)1===n[f]?d[u++]=o[f]:d[u++]=i[f];return s},a.prototype.where=function(t){p([t],"where");var e=this.readSync(t.dataId);return y(t.shape,e)},a.prototype.topk=function(t,e,r){p(t,"topk");var a=this.readSync(t.dataId);return v(a,t.shape,t.dtype,e,r)},a.prototype.min=function(t,r){p(t,"min"),e.backend_util.assertAxesAreInnerMostDims("min",r,t.rank);for(var a=e.backend_util.computeOutAndReduceShapes(t.shape,r),n=a[0],o=a[1],i=e.zeros(n,t.dtype),s=e.util.sizeFromShape(o),d=this.readSync(i.dataId),u=this.readSync(t.dataId),h=0;h<d.length;++h){for(var f=h*s,l=u[f],c=0;c<s;++c){var v=u[f+c];v<l&&(l=v)}d[h]=l}return i},a.prototype.minimum=function(t,e){return p([t,e],"minimum"),this.broadcastedBinaryOp(t,e,t.dtype,(function(t,e){return Math.min(t,e)}))},a.prototype.mod=function(t,e){return p([t,e],"mod"),this.broadcastedBinaryOp(t,e,t.dtype,(function(t,e){var r=t%e;return t<0&&e<0||t>=0&&e>=0?r:(r+e)%e}))},a.prototype.maximum=function(t,e){return p([t,e],"maximum"),this.broadcastedBinaryOp(t,e,t.dtype,(function(t,e){return Math.max(t,e)}))},a.prototype.all=function(t,r){p(t,"all"),e.backend_util.assertAxesAreInnerMostDims("all",r,t.rank);for(var a=e.backend_util.computeOutAndReduceShapes(t.shape,r),n=a[0],o=a[1],i=e.zeros(n,t.dtype),s=e.util.sizeFromShape(o),d=this.readSync(i.dataId),u=this.readSync(t.dataId),h=0;h<d.length;++h){for(var f=h*s,l=u[f],c=0;c<s;++c){var v=u[f+c];l=l&&v}d[h]=l}return i},a.prototype.any=function(t,r){p(t,"any"),e.backend_util.assertAxesAreInnerMostDims("any",r,t.rank);for(var a=e.backend_util.computeOutAndReduceShapes(t.shape,r),n=a[0],o=a[1],i=e.zeros(n,t.dtype),s=e.util.sizeFromShape(o),d=this.readSync(i.dataId),u=this.readSync(t.dataId),h=0;h<d.length;++h){for(var f=h*s,l=u[f],c=0;c<s;++c){var v=u[f+c];l=l||v}d[h]=l}return i},a.prototype.squaredDifference=function(t,e){return p([t,e],"squaredDifference"),this.broadcastedBinaryOp(t,e,t.dtype,(function(t,e){var r=t-e;return r*r}))},a.prototype.ceil=function(t){p(t,"ceil");for(var e=this.readSync(t.dataId),r=new Float32Array(e.length),a=0;a<e.length;++a)r[a]=Math.ceil(e[a]);return this.makeOutput(r,t.shape,"float32")},a.prototype.floor=function(t){p(t,"floor");for(var e=this.readSync(t.dataId),r=new Float32Array(e.length),a=0;a<e.length;++a)r[a]=Math.floor(e[a]);return this.makeOutput(r,t.shape,"float32")},a.prototype.sign=function(t){p(t,"x");for(var e=this.readSync(t.dataId),r=new Float32Array(e.length),a=0;a<e.length;++a)e[a]<0?r[a]=-1:e[a]>0?r[a]=1:r[a]=0;return this.makeOutput(r,t.shape,"float32")},a.prototype.isNaN=function(t){p(t,"x");for(var e=this.readSync(t.dataId),r=new Uint8Array(e.length),a=0;a<e.length;++a)Number.isNaN(e[a])&&(r[a]=1);return this.makeOutput(r,t.shape,"bool")},a.prototype.isInf=function(t){p(t,"x");for(var e=this.readSync(t.dataId),r=new Uint8Array(e.length),a=0;a<e.length;++a)Math.abs(e[a])===1/0&&(r[a]=1);return this.makeOutput(r,t.shape,"bool")},a.prototype.isFinite=function(t){p(t,"x");for(var e=this.readSync(t.dataId),r=new Uint8Array(e.length),a=0;a<e.length;++a)Number.isFinite(e[a])&&(r[a]=1);return this.makeOutput(r,t.shape,"bool")},a.prototype.round=function(t){p(t,"round");for(var e=this.readSync(t.dataId),r=new Float32Array(e.length),a=0;a<e.length;++a){var n=Math.floor(e[a]);e[a]-n<.5?r[a]=Math.floor(e[a]):e[a]-n>.5?r[a]=Math.ceil(e[a]):r[a]=n%2==0?n:n+1}return this.makeOutput(r,t.shape,"float32")},a.prototype.exp=function(t){p(t,"exp");for(var e=this.readSync(t.dataId),r=new Float32Array(e.length),a=0;a<e.length;++a)r[a]=Math.exp(e[a]);return this.makeOutput(r,t.shape,"float32")},a.prototype.expm1=function(t){p(t,"expm1");for(var e=this.readSync(t.dataId),r=new Float32Array(e.length),a=0;a<e.length;++a)r[a]=Math.expm1(e[a]);return this.makeOutput(r,t.shape,"float32")},a.prototype.log=function(t){p(t,"log");for(var e=this.readSync(t.dataId),r=new Float32Array(e.length),a=0;a<e.length;++a){var n=e[a];r[a]=Math.log(n)}return this.makeOutput(r,t.shape,"float32")},a.prototype.log1p=function(t){p(t,"log1p");for(var e=this.readSync(t.dataId),r=new Float32Array(e.length),a=0;a<e.length;++a){var n=e[a];r[a]=Math.log1p(n)}return this.makeOutput(r,t.shape,"float32")},a.prototype.sqrt=function(t){p(t,"sqrt");for(var e=this.readSync(t.dataId),r=new Float32Array(e.length),a=0;a<e.length;++a){var n=e[a];r[a]=Math.sqrt(n)}return this.makeOutput(r,t.shape,"float32")},a.prototype.rsqrt=function(t){p(t,"rsqrt");for(var e=this.readSync(t.dataId),r=new Float32Array(e.length),a=0;a<e.length;++a){var n=e[a];r[a]=1/Math.sqrt(n)}return this.makeOutput(r,t.shape,"float32")},a.prototype.reciprocal=function(t){p(t,"reciprocal");for(var e=this.readSync(t.dataId),r=new Float32Array(e.length),a=0;a<e.length;++a)r[a]=1/e[a];return this.makeOutput(r,t.shape,"float32")},a.prototype.linear=function(t){return t},a.prototype.relu=function(t){p(t,"relu");for(var r=e.zeros(t.shape,t.dtype),a=this.readSync(r.dataId),n=this.readSync(t.dataId),o=0;o<n.length;++o)a[o]=Math.max(0,n[o]);return r},a.prototype.relu6=function(t){p(t,"relu");for(var r=e.zeros(t.shape,t.dtype),a=this.readSync(r.dataId),n=this.readSync(t.dataId),o=0;o<n.length;++o)a[o]=Math.min(Math.max(0,n[o]),6);return r},a.prototype.prelu=function(t,e){return p([t,e],"prelu"),this.broadcastedBinaryOp(t,e,t.dtype,(function(t,e){return t<0?e*t:t}))},a.prototype.elu=function(t){p(t,"elu");for(var e=new Float32Array(t.size),r=this.readSync(t.dataId),a=0;a<r.length;++a){var n=r[a];e[a]=n>=0?n:Math.exp(n)-1}return this.makeOutput(e,t.shape,"float32")},a.prototype.eluDer=function(t,e){p([t,e],"eluDer");for(var r=new Float32Array(e.size),a=this.readSync(e.dataId),n=this.readSync(t.dataId),o=0;o<a.length;++o){var i=a[o];r[o]=i>=1?n[o]:n[o]*(i+1)}return this.makeOutput(r,e.shape,"float32")},a.prototype.selu=function(t){p(t,"selu");for(var r=e.backend_util.SELU_SCALEALPHA,a=e.backend_util.SELU_SCALE,n=new Float32Array(t.size),o=this.readSync(t.dataId),i=0;i<o.length;++i){var s=o[i];n[i]=s>=0?a*s:r*(Math.exp(s)-1)}return this.makeOutput(n,t.shape,"float32")},a.prototype.clip=function(t,e,r){p(t,"clip");for(var a=new Float32Array(t.size),n=this.readSync(t.dataId),o=0;o<n.length;++o){var i=n[o];a[o]=i>r?r:i<e?e:i}return this.makeOutput(a,t.shape,"float32")},a.prototype.abs=function(t){for(var e=new Float32Array(t.size),r=this.readSync(t.dataId),a=0;a<r.length;++a)e[a]=Math.abs(r[a]);return this.makeOutput(e,t.shape,"float32")},a.prototype.complexAbs=function(t){for(var e=new Float32Array(t.size),r=this.readSync(t.dataId),a=0;a<t.size;++a){var n=r[2*a],o=r[2*a+1];e[a]=Math.hypot(n,o)}return this.makeOutput(e,t.shape,"float32")},a.prototype.int=function(t){p(t,"int");for(var e=new Int32Array(t.size),r=this.readSync(t.dataId),a=0;a<r.length;++a)e[a]=r[a];return this.makeOutput(e,t.shape,"int32")},a.prototype.sigmoid=function(t){p(t,"sigmoid");for(var e=new Float32Array(t.size),r=this.readSync(t.dataId),a=0;a<r.length;++a)e[a]=1/(1+Math.exp(-r[a]));return this.makeOutput(e,t.shape,"float32")},a.prototype.softplus=function(t){p(t,"softplus");for(var e=Math.log(1.1920928955078125e-7)+2,r=new Float32Array(t.size),a=this.readSync(t.dataId),n=0;n<a.length;++n){var o=a[n]>-e,i=a[n]<e,s=Math.exp(a[n]),d=void 0;d=i?s:o?a[n]:Math.log(1+s),r[n]=d}return this.makeOutput(r,t.shape,"float32")},a.prototype.sin=function(t){p(t,"sin");for(var e=new Float32Array(t.size),r=this.readSync(t.dataId),a=0;a<r.length;++a)e[a]=Math.sin(r[a]);return this.makeOutput(e,t.shape,"float32")},a.prototype.cos=function(t){p(t,"cos");for(var e=new Float32Array(t.size),r=this.readSync(t.dataId),a=0;a<r.length;++a)e[a]=Math.cos(r[a]);return this.makeOutput(e,t.shape,"float32")},a.prototype.tan=function(t){p(t,"tan");for(var e=new Float32Array(t.size),r=this.readSync(t.dataId),a=0;a<r.length;++a)e[a]=Math.tan(r[a]);return this.makeOutput(e,t.shape,"float32")},a.prototype.asin=function(t){p(t,"asin");for(var e=new Float32Array(t.size),r=this.readSync(t.dataId),a=0;a<r.length;++a)e[a]=Math.asin(r[a]);return this.makeOutput(e,t.shape,"float32")},a.prototype.acos=function(t){p(t,"acos");for(var e=new Float32Array(t.size),r=this.readSync(t.dataId),a=0;a<r.length;++a)e[a]=Math.acos(r[a]);return this.makeOutput(e,t.shape,"float32")},a.prototype.atan=function(t){p(t,"atan");for(var e=new Float32Array(t.size),r=this.readSync(t.dataId),a=0;a<r.length;++a)e[a]=Math.atan(r[a]);return this.makeOutput(e,t.shape,"float32")},a.prototype.atan2=function(t,e){return p([t,e],"atan2"),this.broadcastedBinaryOp(t,e,t.dtype,(function(t,e){return Math.atan2(t,e)}))},a.prototype.sinh=function(t){p(t,"sinh");for(var e=new Float32Array(t.size),r=this.readSync(t.dataId),a=0;a<r.length;++a)e[a]=Math.sinh(r[a]);return this.makeOutput(e,t.shape,"float32")},a.prototype.cosh=function(t){p(t,"cosh");for(var e=new Float32Array(t.size),r=this.readSync(t.dataId),a=0;a<r.length;++a)e[a]=Math.cosh(r[a]);return this.makeOutput(e,t.shape,"float32")},a.prototype.tanh=function(t){p(t,"tanh");for(var r=new Float32Array(t.size),a=this.readSync(t.dataId),n=0;n<a.length;++n)r[n]=e.util.tanh(a[n]);return this.makeOutput(r,t.shape,"float32")},a.prototype.asinh=function(t){p(t,"asinh");for(var e=new Float32Array(t.size),r=this.readSync(t.dataId),a=0;a<r.length;++a)e[a]=Math.asinh(r[a]);return this.makeOutput(e,t.shape,"float32")},a.prototype.acosh=function(t){p(t,"acosh");for(var e=new Float32Array(t.size),r=this.readSync(t.dataId),a=0;a<r.length;++a)e[a]=Math.acosh(r[a]);return this.makeOutput(e,t.shape,"float32")},a.prototype.atanh=function(t){p(t,"atanh");for(var e=new Float32Array(t.size),r=this.readSync(t.dataId),a=0;a<r.length;++a)e[a]=Math.atanh(r[a]);return this.makeOutput(e,t.shape,"float32")},a.prototype.erf=function(t){p(t,"erf");for(var r=new Float32Array(t.size),a=this.readSync(t.dataId),n=e.backend_util.ERF_P,o=e.backend_util.ERF_A1,i=e.backend_util.ERF_A2,s=e.backend_util.ERF_A3,d=e.backend_util.ERF_A4,u=e.backend_util.ERF_A5,h=0;h<a.length;++h){var f=Math.sign(a[h]),l=Math.abs(a[h]),c=1/(1+n*l);r[h]=f*(1-((((u*c+d)*c+s)*c+i)*c+o)*c*Math.exp(-l*l))}return this.makeOutput(r,t.shape,"float32")},a.prototype.step=function(t,e){void 0===e&&(e=0),p(t,"step");for(var r=new Float32Array(t.size),a=this.readSync(t.dataId),n=0;n<a.length;++n){var o=a[n];isNaN(o)?r[n]=NaN:r[n]=o>0?1:e}return this.makeOutput(r,t.shape,"float32")},a.prototype.fusedConv2d=function(t){var e=t.input,r=t.filter,a=t.convInfo,n=t.bias,o=t.activation,i=t.preluActivationWeights,s=this.conv2d(e,r,a);return n&&(s=this.add(s,n)),o&&(s=m(this,s,o,i)),s},a.prototype.conv2d=function(t,r,a){p([t,r],"conv2d");for(var n=a.filterHeight,o=a.filterWidth,i=a.dilationHeight,s=a.dilationWidth,d=a.padInfo.left,u=a.padInfo.top,h="channelsLast"===a.dataFormat,f=e.buffer(a.outShape,t.dtype),l=t.strides[0],c=h?t.strides[1]:t.strides[2],v=h?t.strides[2]:1,y=h?1:t.strides[1],m=f.strides[0],g=h?f.strides[1]:f.strides[2],S=h?f.strides[2]:1,I=h?1:f.strides[1],b=this.readSync(t.dataId),k=this.readSync(r.dataId),M=f.values,x=0;x<a.batchSize;++x)for(var A=x*l,F=x*m,D=0;D<a.outHeight;++D)for(var w=F+D*g,T=D*a.strideHeight-u,N=0;N<n;N++){var z=T+N*i;if(!(z<0||z>=a.inHeight))for(var W=N*r.strides[0],_=A+z*c,H=0;H<a.outWidth;++H)for(var O=w+H*S,C=H*a.strideWidth-d,B=0;B<o;B++){var E=C+B*s;if(!(E<0||E>=a.inWidth))for(var P=_+E*v,R=W+B*r.strides[1],q=0;q<a.inChannels;++q){for(var L=b[P+q*y],U=0;U<a.outChannels;++U)M[O+U*I]+=L*k[R+U];R+=a.outChannels}}}return f.toTensor()},a.prototype.conv3d=function(t,r,a){for(var n=a.filterDepth,o=a.filterHeight,i=a.filterWidth,s=a.dilationDepth,d=a.dilationHeight,p=a.dilationWidth,u=a.padInfo.front,h=a.padInfo.left,f=a.padInfo.top,l=e.buffer(a.outShape,t.dtype),c=this.readSync(t.dataId),v=this.readSync(r.dataId),y=l.values,m=0;m<a.batchSize;++m)for(var g=m*t.strides[0],S=m*l.strides[0],I=0;I<a.outDepth;++I)for(var b=S+I*l.strides[1],k=I*a.strideDepth-u,M=0;M<n;M++){var x=k+M*s;if(!(x<0||x>=a.inDepth))for(var A=M*r.strides[0],F=g+x*t.strides[1],D=0;D<a.outHeight;++D)for(var w=b+D*l.strides[2],T=D*a.strideHeight-f,N=0;N<o;N++){var z=T+N*d;if(!(z<0||z>=a.inHeight))for(var W=A+N*r.strides[1],_=F+z*t.strides[2],H=0;H<a.outWidth;++H)for(var O=w+H*a.outChannels,C=H*a.strideWidth-h,B=0;B<i;B++){var E=C+B*p;if(!(E<0||E>=a.inWidth))for(var P=W+B*r.strides[2],R=_+E*a.inChannels,q=P,L=0;L<a.inChannels;++L){for(var U=c[R+L],G=0;G<a.outChannels;++G)y[O+G]+=U*v[q+G];q+=a.outChannels}}}}return l.toTensor()},a.prototype.conv2dDerInput=function(t,r,a){p([t,r],"conv2dDerInput");for(var n=e.buffer(a.inShape,"float32"),o=n.values,i=this.readSync(t.dataId),s=this.readSync(r.dataId),d=r.strides,u=d[0],h=d[1],f=d[2],l=a.batchSize,c=a.filterHeight,v=a.filterWidth,y=a.inChannels,m=a.inHeight,g=a.inWidth,S=a.outChannels,I=a.outHeight,b=a.outWidth,k=a.strideHeight,M=a.strideWidth,x=a.dataFormat,A=c-1-a.padInfo.top,F=v-1-a.padInfo.left,D="channelsLast"===x,w=n.strides[0],T=D?n.strides[1]:n.strides[2],N=D?n.strides[2]:1,z=D?1:n.strides[1],W=t.strides[0],_=D?t.strides[1]:t.strides[2],H=D?t.strides[2]:1,O=D?1:t.strides[1],C=0;C<l;++C)for(var B=0;B<y;++B)for(var E=0;E<m;++E)for(var P=E-A,R=Math.max(0,Math.ceil(P/k)),q=Math.min(I,(c+P)/k),L=0;L<g;++L){for(var U=L-F,G=Math.max(0,Math.ceil(U/M)),V=Math.min(b,(v+U)/M),j=0,Y=R;Y<q;++Y)for(var K=Y*k-P,Z=G;Z<V;++Z)for(var J=W*C+_*Y+H*Z,Q=u*(c-1-K)+h*(v-1-(Z*M-U))+f*B,X=0;X<S;++X){j+=i[J+O*X]*s[Q+X]}o[w*C+T*E+N*L+z*B]=j}return n.toTensor()},a.prototype.conv3dDerInput=function(t,r,a){for(var n=e.buffer(a.inShape,"float32"),o=n.values,i=n.strides,s=i[0],d=i[1],p=i[2],u=i[3],h=this.readSync(t.dataId),f=t.strides,l=f[0],c=f[1],v=f[2],y=f[3],m=this.readSync(r.dataId),g=r.strides,S=g[0],I=g[1],b=g[2],k=g[3],M=a.batchSize,x=a.filterDepth,A=a.filterHeight,F=a.filterWidth,D=a.inChannels,w=a.inDepth,T=a.inHeight,N=a.inWidth,z=a.outChannels,W=a.outDepth,_=a.outHeight,H=a.outWidth,O=a.strideDepth,C=a.strideHeight,B=a.strideWidth,E=x-1-a.padInfo.front,P=A-1-a.padInfo.top,R=F-1-a.padInfo.left,q=0;q<M;++q)for(var L=0;L<D;++L)for(var U=0;U<w;++U)for(var G=U-E,V=Math.max(0,Math.ceil(G/O)),j=Math.min(W,(x+G)/O),Y=0;Y<T;++Y)for(var K=Y-P,Z=Math.max(0,Math.ceil(K/C)),J=Math.min(_,(A+K)/C),Q=0;Q<N;++Q){for(var X=Q-R,$=Math.max(0,Math.ceil(X/B)),tt=Math.min(H,(F+X)/B),et=0,rt=V;rt<j;++rt)for(var at=rt*O-G,nt=Z;nt<J;++nt)for(var ot=nt*C-K,it=$;it<tt;++it)for(var st=l*q+c*rt+v*nt+y*it,dt=S*(x-1-at)+I*(A-1-ot)+b*(F-1-(it*B-X))+k*L,pt=0;pt<z;++pt){et+=h[st+pt]*m[dt+pt]}o[s*q+d*U+p*Y+u*Q+L]=et}return n.toTensor()},a.prototype.conv2dDerFilter=function(t,r,a){p([t,r],"conv2dDerFilter");for(var n=a.strideHeight,o=a.strideWidth,i=a.filterHeight,s=a.filterWidth,d="channelsLast"===a.dataFormat,u=e.buffer(a.filterShape,"float32"),h=a.padInfo.left,f=a.padInfo.top,l=this.bufferSync(t),c=this.bufferSync(r),v=0;v<i;++v)for(var y=Math.max(0,Math.ceil((f-v)/n)),m=Math.min(a.outHeight,(a.inHeight+f-v)/n),g=0;g<s;++g)for(var S=Math.max(0,Math.ceil((h-g)/o)),I=Math.min(a.outWidth,(a.inWidth+h-g)/o),b=0;b<a.inChannels;++b)for(var k=0;k<a.outChannels;++k){for(var M=0,x=0;x<a.batchSize;++x)for(var A=y;A<m;++A)for(var F=v+A*n-f,D=S;D<I;++D){var w=g+D*o-h;M+=d?l.get(x,F,w,b)*c.get(x,A,D,k):l.get(x,b,F,w)*c.get(x,k,A,D)}u.set(M,v,g,b,k)}return u.toTensor()},a.prototype.conv3dDerFilter=function(t,r,a){for(var n=a.strideDepth,o=a.strideHeight,i=a.strideWidth,s=a.filterDepth,d=a.filterHeight,p=a.filterWidth,u=e.buffer(a.filterShape,"float32"),h=u.values,f=u.strides,l=f[0],c=f[1],v=f[2],y=f[3],m=this.readSync(r.dataId),g=r.strides,S=g[0],I=g[1],b=g[2],k=g[3],M=this.readSync(t.dataId),x=t.strides,A=x[0],F=x[1],D=x[2],w=x[3],T=a.padInfo.front,N=a.padInfo.left,z=a.padInfo.top,W=0;W<s;++W)for(var _=Math.max(0,Math.ceil((T-W)/n)),H=Math.min(a.outDepth,(a.inDepth+T-W)/n),O=W*l,C=0;C<d;++C)for(var B=Math.max(0,Math.ceil((z-C)/o)),E=Math.min(a.outHeight,(a.inHeight+z-C)/o),P=C*c+O,R=0;R<p;++R)for(var q=Math.max(0,Math.ceil((N-R)/i)),L=Math.min(a.outWidth,(a.inWidth+N-R)/i),U=R*v+P,G=0;G<a.inChannels;++G)for(var V=G*y+U,j=0;j<a.outChannels;++j){for(var Y=0,K=0;K<a.batchSize;++K)for(var Z=K*A,J=K*S,Q=_;Q<H;++Q)for(var X=(W+Q*n-T)*F+Z,$=Q*I+J,tt=B;tt<E;++tt)for(var et=(C+tt*o-z)*D+X,rt=tt*b+$,at=q;at<L;++at){var nt=at*k+rt;Y+=M[(R+at*i-N)*w+et+G]*m[nt+j]}h[V+j]=Y}return u.toTensor()},a.prototype.fusedDepthwiseConv2D=function(t){var e=t.input,r=t.filter,a=t.convInfo,n=t.bias,o=t.activation,i=t.preluActivationWeights,s=this.depthwiseConv2D(e,r,a);return n&&(s=this.add(s,n)),o&&(s=m(this,s,o,i)),s},a.prototype.depthwiseConv2D=function(t,r,a){p([t,r],"depthwiseConv2D");for(var n=a.filterHeight,o=a.filterWidth,i=a.dilationHeight,s=a.dilationWidth,d=a.padInfo.left,u=a.padInfo.top,h=a.outChannels/a.inChannels,f=e.buffer(a.outShape,t.dtype),l=this.readSync(t.dataId),c=this.readSync(r.dataId),v=f.values,y=0;y<a.batchSize;++y)for(var m=y*t.strides[0],g=y*f.strides[0],S=0;S<a.outHeight;++S)for(var I=g+S*f.strides[1],b=S*a.strideHeight-d,k=0;k<n;++k){var M=b+k*i;if(!(M<0||M>=a.inHeight))for(var x=k*r.strides[0],A=m+M*t.strides[1],F=0;F<a.outWidth;++F)for(var D=I+F*f.strides[2],w=F*a.strideWidth-u,T=0;T<o;++T){var N=w+T*s;if(!(N<0||N>=a.inWidth))for(var z=x+T*r.strides[1],W=A+N*a.inChannels,_=D,H=z,O=0;O<a.inChannels;++O){for(var C=l[W+O],B=0;B<h;++B)v[_+B]+=C*c[H+B];_+=h,H+=h}}}return f.toTensor()},a.prototype.depthwiseConv2DDerInput=function(t,r,a){p([t,r],"depthwiseConv2DDerInput");for(var n=e.buffer(a.inShape,"float32"),o=n.values,i=n.strides,s=i[0],d=i[1],u=i[2],h=this.readSync(t.dataId),f=t.strides,l=f[0],c=f[1],v=f[2],y=this.readSync(r.dataId),m=r.strides,g=m[0],S=m[1],I=m[2],b=a.batchSize,k=a.filterHeight,M=a.filterWidth,x=a.inChannels,A=a.inHeight,F=a.inWidth,D=a.outChannels,w=a.outHeight,T=a.outWidth,N=a.strideHeight,z=a.strideWidth,W=k-1-a.padInfo.top,_=M-1-a.padInfo.left,H=D/x,O=0;O<b;++O)for(var C=0;C<x;++C)for(var B=0;B<A;++B)for(var E=B-W,P=Math.max(0,Math.ceil(E/N)),R=Math.min(w,(k+E)/N),q=0;q<F;++q){for(var L=q-_,U=Math.max(0,Math.ceil(L/z)),G=Math.min(T,(M+L)/z),V=0,j=P;j<R;++j)for(var Y=j*N-E,K=U;K<G;++K)for(var Z=l*O+c*j+v*K,J=g*(k-1-Y)+S*(M-1-(K*z-L))+I*C,Q=0;Q<H;++Q){V+=h[Z+(C*H+Q)]*y[J+Q]}o[s*O+d*B+u*q+C]=V}return n.toTensor()},a.prototype.depthwiseConv2DDerFilter=function(t,r,a){p([t,r],"depthwiseConv2DDerFilter");for(var n=a.strideHeight,o=a.strideWidth,i=a.filterHeight,s=a.filterWidth,d=e.buffer(a.filterShape,"float32"),u=a.padInfo.left,h=a.padInfo.top,f=a.outChannels/a.inChannels,l=this.bufferSync(t),c=this.bufferSync(r),v=0;v<i;++v)for(var y=Math.max(0,Math.ceil((h-v)/n)),m=Math.min(a.outHeight,(a.inHeight+h-v)/n),g=0;g<s;++g)for(var S=Math.max(0,Math.ceil((u-g)/o)),I=Math.min(a.outWidth,(a.inWidth+u-g)/o),b=0;b<a.outChannels;++b){for(var k=Math.trunc(b/f),M=b%f,x=0,A=0;A<a.batchSize;++A)for(var F=y;F<m;++F)for(var D=v+F*n-h,w=S;w<I;++w){var T=g+w*o-u;x+=l.get(A,D,T,k)*c.get(A,F,w,b)}d.set(x,v,g,k,M)}return d.toTensor()},a.prototype.tile=function(t,e){return p(t,"tile"),c(this.bufferSync(t),e)},a.prototype.pad=function(t,r,a){p(t,"pad");var n=r.map((function(e,r){return e[0]+t.shape[r]+e[1]})),o=r.map((function(t){return t[0]})),i=this.bufferSync(t),s=e.buffer(n,t.dtype);0!==a&&s.values.fill(a);for(var d=0;d<t.size;d++){var u=i.indexToLoc(d),h=u.map((function(t,e){return t+o[e]}));s.set.apply(s,[i.get.apply(i,u)].concat(h))}return s.toTensor()},a.prototype.gather=function(t,r,a){p([t,r],"gather");var n=t.shape.slice(),o=this.readSync(r.dataId);n[a]=o.length;for(var i=e.buffer(n,t.dtype),s=this.bufferSync(t),d=0;d<i.size;++d){var u=i.indexToLoc(d),h=u.slice();h[a]=o[u[a]];var f=s.locToIndex(h);i.values[d]=s.values[f]}return i.toTensor()},a.prototype.batchToSpaceND=function(t,r,a){p([t],"batchToSpaceND");var n=r.reduce((function(t,e){return t*e})),o=e.backend_util.getReshaped(t.shape,r,n),i=e.backend_util.getPermuted(o.length,r.length),s=e.backend_util.getReshapedPermuted(t.shape,r,n),d=e.backend_util.getSliceBeginCoords(a,r.length),u=e.backend_util.getSliceSize(s,a,r.length);return e.transpose(t.reshape(o),i).reshape(s).slice(d,u)},a.prototype.spaceToBatchND=function(t,r,a){p([t],"spaceToBatchND");var n=r.reduce((function(t,e){return t*e})),o=[[0,0]];o.push.apply(o,a);for(var i=1+r.length;i<t.shape.length;++i)o.push([0,0]);var s=t.pad(o),d=e.backend_util.getReshaped(s.shape,r,n,!1),u=e.backend_util.getPermuted(d.length,r.length,!1),h=e.backend_util.getReshapedPermuted(s.shape,r,n,!1),f=e.transpose(s.reshape(d),u);return e.reshape(f,h)},a.prototype.maxPool=function(t,e){return p(t,"maxPool"),u(this.readSync(t.dataId),t.shape,t.dtype,t.strides,e,"max").toTensor()},a.prototype.maxPoolBackprop=function(t,r,a,n){p([r,a],"maxPoolBackprop");for(var o=this.readSync(r.dataId),i=e.buffer(n.outShape,r.dtype,h(o,r.shape,r.dtype,n).values),s=n.strideHeight,d=n.strideWidth,u=n.dilationHeight,f=n.dilationWidth,l=n.effectiveFilterHeight,c=n.effectiveFilterWidth,v=c-1-n.padInfo.left,y=l-1-n.padInfo.top,m=e.buffer(r.shape,"float32"),g=this.bufferSync(t),S=0;S<n.batchSize;++S)for(var I=0;I<n.inChannels;++I)for(var b=0;b<n.inHeight;++b)for(var k=0;k<n.inWidth;++k){for(var M=b-y,x=k-v,A=0,F=0;F<l;F+=u){var D=(M+F)/s;if(!(D<0||D>=n.outHeight||Math.floor(D)!==D))for(var w=0;w<c;w+=f){var T=(x+w)/d;if(!(T<0||T>=n.outWidth||Math.floor(T)!==T)){var N=l*c-1-i.get(S,D,T,I)===F*c+w?1:0;if(0!==N)A+=g.get(S,D,T,I)*N}}}m.set(A,S,b,k,I)}return m.toTensor()},a.prototype.avgPoolBackprop=function(t,r,a){p([t,r],"avgPoolBackprop");for(var n=a.strideHeight,o=a.strideWidth,i=a.filterHeight,s=a.filterWidth,d=a.dilationHeight,u=a.dilationWidth,h=a.effectiveFilterHeight,f=a.effectiveFilterWidth,l=f-1-a.padInfo.left,c=h-1-a.padInfo.top,v=e.buffer(r.shape,"float32"),y=1/(i*s),m=this.bufferSync(t),g=0;g<a.batchSize;++g)for(var S=0;S<a.inChannels;++S)for(var I=0;I<a.inHeight;++I)for(var b=0;b<a.inWidth;++b){for(var k=I-c,M=b-l,x=0,A=0;A<h;A+=d){var F=(k+A)/n;if(!(F<0||F>=a.outHeight||Math.floor(F)!==F))for(var D=0;D<f;D+=u){var w=(M+D)/o;if(!(w<0||w>=a.outWidth||Math.floor(w)!==w))x+=m.get(g,F,w,S)}}v.set(x*y,g,I,b,S)}return v.toTensor()},a.prototype.pool3d=function(t,r,a){p(t,"pool3d");for(var n=r.strideDepth,o=r.strideHeight,i=r.strideWidth,s=r.dilationDepth,d=r.dilationHeight,u=r.dilationWidth,h=r.effectiveFilterDepth,f=r.effectiveFilterHeight,l=r.effectiveFilterWidth,c=r.padInfo.front,v=r.padInfo.top,y=r.padInfo.left,m="max"===a?Number.NEGATIVE_INFINITY:Number.POSITIVE_INFINITY,g=this.readSync(t.dataId),S=e.buffer(r.outShape,t.dtype),I=S.values,b=r.outShape[1]*r.outShape[2]*r.outShape[3]*r.outShape[4],k=r.outShape[2]*r.outShape[3]*r.outShape[4],M=r.outShape[3]*r.outShape[4],x=r.outShape[4],A=0;A<r.batchSize;++A)for(var F=A*b,D=A*t.strides[0],w=0;w<r.inChannels;++w)for(var T=0;T<r.outDepth;++T){for(var N=T*n-c,z=N;z<0;)z+=s;for(var W=Math.min(r.inDepth,h+N),_=F+T*k,H=0;H<r.outHeight;++H){for(var O=H*o-v,C=O;C<0;)C+=d;for(var B=Math.min(r.inHeight,f+O),E=_+H*M,P=0;P<r.outWidth;++P){for(var R=P*i-y,q=R;q<0;)q+=u;for(var L=Math.min(r.inWidth,l+R),U=E+P*x,G=m,V=0,j=0,Y=z;Y<W;Y+=s){for(var K=D+Y*t.strides[1],Z=C;Z<B;Z+=d){for(var J=K+Z*t.strides[2],Q=q;Q<L;Q+=u){var X=g[J+Q*t.strides[3]+w];if("max"===a&&X>G?G=X:"avg"===a&&(V+=X,j++),isNaN(G))break}if(isNaN(G))break}if(isNaN(G))break}I[U+w]="avg"===a?V/j:G}}}return S.toTensor()},a.prototype.avgPool3d=function(t,e){return p(t,"avgPool3d"),this.pool3d(t,e,"avg").toFloat()},a.prototype.avgPool3dBackprop=function(t,r,a){p([t,r],"avgPool3dBackprop");for(var n=a.strideDepth,o=a.strideHeight,i=a.strideWidth,s=a.filterDepth,d=a.filterHeight,u=a.filterWidth,h=a.dilationDepth,f=a.dilationHeight,l=a.dilationWidth,c=a.effectiveFilterDepth,v=a.effectiveFilterHeight,y=a.effectiveFilterWidth,m=c-1-a.padInfo.front,g=y-1-a.padInfo.left,S=v-1-a.padInfo.top,I=e.buffer(r.shape,"float32"),b=1/(s*d*u),k=this.bufferSync(t),M=0;M<a.batchSize;++M)for(var x=0;x<a.inChannels;++x)for(var A=0;A<a.inDepth;++A)for(var F=0;F<a.inHeight;++F)for(var D=0;D<a.inWidth;++D){for(var w=A-m,T=F-S,N=D-g,z=0,W=0;W<c;W+=h){var _=(w+W)/n;if(!(_<0||_>=a.outDepth||Math.floor(_)!==_))for(var H=0;H<v;H+=f){var O=(T+H)/o;if(!(O<0||O>=a.outHeight||Math.floor(O)!==O))for(var C=0;C<y;C+=l){var B=(N+C)/i;if(!(B<0||B>=a.outWidth||Math.floor(B)!==B))z+=k.get(M,_,O,B,x)}}}I.set(z*b,M,A,F,D,x)}return I.toTensor()},a.prototype.maxPool3d=function(t,e){return p(t,"maxPool3d"),this.pool3d(t,e,"max").toFloat()},a.prototype.maxPool3dPositions=function(t,r){for(var a=e.buffer(r.outShape,"int32"),n=r.strideDepth,o=r.strideHeight,i=r.strideWidth,s=r.dilationDepth,d=r.dilationHeight,p=r.dilationWidth,u=r.effectiveFilterDepth,h=r.effectiveFilterHeight,f=r.effectiveFilterWidth,l=r.padInfo.front,c=r.padInfo.top,v=r.padInfo.left,y=this.bufferSync(t),m=0;m<r.batchSize;++m)for(var g=0;g<r.inChannels;++g)for(var S=0;S<r.outDepth;++S){for(var I=S*n-l,b=I;b<0;)b+=s;for(var k=Math.min(r.inDepth,u+I),M=0;M<r.outHeight;++M){for(var x=M*o-c,A=x;A<0;)A+=d;for(var F=Math.min(r.inHeight,h+x),D=0;D<r.outWidth;++D){for(var w=D*i-v,T=w;T<0;)T+=p;for(var N=Math.min(r.inWidth,f+w),z=Number.NEGATIVE_INFINITY,W=-1,_=b;_<k;_+=s)for(var H=_-I,O=A;O<F;O+=d)for(var C=O-x,B=T;B<N;B+=p){var E=B-w,P=y.get(m,_,O,B,g);P>=z&&(z=P,W=H*h*f+C*h+E)}a.set(W,m,S,M,D,g)}}}return a.toTensor()},a.prototype.maxPool3dBackprop=function(t,r,a,n){p([r,a],"maxPool3dBackprop");for(var o=this.maxPool3dPositions(r,n),i=n.strideDepth,s=n.strideHeight,d=n.strideWidth,u=n.dilationDepth,h=n.dilationHeight,f=n.dilationWidth,l=n.effectiveFilterDepth,c=n.effectiveFilterHeight,v=n.effectiveFilterWidth,y=l-1-n.padInfo.front,m=v-1-n.padInfo.left,g=c-1-n.padInfo.top,S=e.buffer(r.shape,"float32"),I=this.bufferSync(o),b=this.bufferSync(t),k=0;k<n.batchSize;++k)for(var M=0;M<n.inChannels;++M)for(var x=0;x<n.inDepth;++x)for(var A=0;A<n.inHeight;++A)for(var F=0;F<n.inWidth;++F){for(var D=x-y,w=A-g,T=F-m,N=0,z=0;z<l;z+=u){var W=(D+z)/i;if(!(W<0||W>=n.outDepth||Math.floor(W)!==W))for(var _=0;_<c;_+=h){var H=(w+_)/s;if(!(H<0||H>=n.outHeight||Math.floor(H)!==H))for(var O=0;O<v;O+=f){var C=(T+O)/d;if(!(C<0||C>=n.outWidth||Math.floor(C)!==C)){var B=l*c*v-1-I.get(k,W,H,C,M)===z*c*v+_*v+O?1:0;if(0!==B)N+=b.get(k,W,H,C,M)*B}}}}S.set(N,k,x,A,F,M)}return S.toTensor()},a.prototype.cast=function(t,r){return e.backend_util.castTensor(t,r,this)},a.prototype.reshape=function(t,r){return e.backend_util.reshapeTensor(t,r)},a.prototype.avgPool=function(t,e){return p(t,"avgPool"),p(t,"maxPool"),u(this.readSync(t.dataId),t.shape,t.dtype,t.strides,e,"avg").toTensor().toFloat()},a.prototype.resizeBilinear=function(t,r,a,n){p(t,"resizeBilinear");for(var o=t.shape,i=o[0],s=o[1],d=o[2],u=o[3],h=this.readSync(t.dataId),f=new Float32Array(e.util.sizeFromShape([i,r,a,u])),l=[n&&r>1?s-1:s,n&&a>1?d-1:d],c=[n&&r>1?r-1:r,n&&a>1?a-1:a],v=0,y=l[0]/c[0],m=l[1]/c[1],g=0;g<i;g++)for(var S=0;S<r;S++)for(var I=y*S,b=Math.floor(I),k=I-b,M=Math.min(s-1,Math.ceil(I)),x=g*t.strides[0]+b*t.strides[1],A=g*t.strides[0]+M*t.strides[1],F=0;F<a;F++)for(var D=m*F,w=Math.floor(D),T=D-w,N=Math.min(d-1,Math.ceil(D)),z=x+w*t.strides[2],W=A+w*t.strides[2],_=x+N*t.strides[2],H=A+N*t.strides[2],O=0;O<u;O++){var C=h[z+O],B=h[W+O],E=C+(h[_+O]-C)*T,P=E+(B+(h[H+O]-B)*T-E)*k;f[v++]=P}return e.tensor(f,[i,r,a,u])},a.prototype.resizeBilinearBackprop=function(t,r,a){p([t,r],"resizeBilinearBackprop");for(var n=r.shape,o=n[0],i=n[1],s=n[2],d=n[3],u=t.shape,h=u[1],f=u[2],l=new Float32Array(o*i*s*d),c=[a&&h>1?i-1:i,a&&f>1?s-1:s],v=[a&&h>1?h-1:h,a&&f>1?f-1:f],y=c[0]/v[0],m=c[1]/v[1],g=this.readSync(t.dataId),S=0,I=0;I<o;I++)for(var b=I*r.strides[0],k=0;k<h;k++)for(var M=k*y,x=Math.floor(M),A=Math.min(Math.ceil(M),i-1),F=b+x*r.strides[1],D=b+A*r.strides[1],w=M-x,T=1-w,N=0;N<f;N++)for(var z=N*m,W=Math.floor(z),_=Math.min(Math.ceil(z),s-1),H=z-W,O=1-H,C=F+W*r.strides[2],B=F+_*r.strides[2],E=D+W*r.strides[2],P=D+_*r.strides[2],R=T*O,q=T*H,L=w*O,U=w*H,G=0;G<d;G++){var V=g[S++];l[C+G]+=V*R,l[B+G]+=V*q,l[E+G]+=V*L,l[P+G]+=V*U}return e.tensor4d(l,[o,s,i,d],r.dtype)},a.prototype.resizeNearestNeighbor=function(t,r,a,n){p(t,"resizeNearestNeighbor");for(var o=t.shape,i=o[0],s=o[1],d=o[2],u=o[3],h=this.readSync(t.dataId),f=new Float32Array(i*r*a*u),l=[n&&r>1?s-1:s,n&&a>1?d-1:d],c=[n&&r>1?r-1:r,n&&a>1?a-1:a],v=l[0]/c[0],y=l[1]/c[1],m=0,g=0;g<i;g++)for(var S=g*t.strides[0],I=0;I<r;I++)for(var b=v*I,k=S+Math.min(s-1,n?Math.round(b):Math.floor(b))*t.strides[1],M=0;M<a;M++)for(var x=y*M,A=k+Math.min(d-1,n?Math.round(x):Math.floor(x))*t.strides[2],F=0;F<u;F++){var D=h[A+F];f[m++]=D}return e.tensor(f,[i,r,a,u],t.dtype)},a.prototype.resizeNearestNeighborBackprop=function(t,r,a){p([t,r],"resizeNearestNeighborBackprop");for(var n=r.shape,o=n[0],i=n[1],s=n[2],d=n[3],u=t.shape,h=u[1],f=u[2],l=new Float32Array(o*i*s*d),c=this.readSync(t.dataId),v=[a&&h>1?i-1:i,a&&f>1?s-1:s],y=[a&&h>1?h-1:h,a&&f>1?f-1:f],m=v[0]/y[0],g=v[1]/y[1],S=1/m,I=1/g,b=2*Math.ceil(S)+2,k=2*Math.ceil(I)+2,M=0;M<o;M++)for(var x=M*r.strides[0],A=0;A<i;A++)for(var F=x+A*r.strides[1],D=Math.floor(A*S),w=Math.floor(D-b/2),T=0;T<s;T++)for(var N=F+T*r.strides[2],z=Math.floor(T*I),W=Math.floor(z-k/2),_=0;_<d;_++){for(var H=0,O=0;O<b;O++){var C=O+w;if(!(C<0||C>=h)){var B=x+C*t.strides[1],E=C*m;if(A===Math.min(i-1,a?Math.round(E):Math.floor(E)))for(var P=0;P<k;P++){var R=P+W;if(!(R<0||R>=f)){var q=B+R*t.strides[2],L=R*g;T===Math.min(s-1,a?Math.round(L):Math.floor(L))&&(H+=c[q+_])}}}}l[N+_]=H}return e.tensor4d(l,r.shape,r.dtype)},a.prototype.batchNorm=function(t,r,a,n,o,i){p([t,r,a,o,n],"batchNorm");for(var s=this.readSync(t.dataId),d=this.readSync(r.dataId),u=this.readSync(a.dataId),h=o?this.readSync(o.dataId):new Float32Array([1]),f=n?this.readSync(n.dataId):new Float32Array([0]),l=new Float32Array(s.length),c=f.length,v=h.length,y=u.length,m=d.length,g=0,S=0,I=0,b=0,k=0;k<s.length;++k)l[k]=f[g++]+(s[k]-d[S++])*h[I++]/Math.sqrt(u[b++]+i),g>=c&&(g=0),S>=m&&(S=0),I>=v&&(I=0),b>=y&&(b=0);return e.tensor4d(l,t.shape)},a.prototype.localResponseNormalization4D=function(t,r,a,n,o){p(t,"localResponseNormalization4D");var i=t.shape[3],s=i-1,d=this.readSync(t.dataId),u=t.size,h=new Float32Array(u);function f(t){for(var e=t%i,a=t-e+Math.max(0,e-r),n=t-e+Math.min(e+r,s),o=0;a<=n;a++){var p=d[a];o+=p*p}return o}for(var l=0;l<u;l++){var c=f(l),v=d[l]*Math.pow(a+n*c,-o);h[l]=v}return e.tensor4d(h,t.shape)},a.prototype.LRNGrad=function(t,r,a,n,o,i,s){p(t,"LRNGrad");for(var d=t.shape[3],u=this.readSync(t.dataId),h=this.readSync(r.dataId),f=this.readSync(a.dataId),l=new Float32Array(t.size),c=t.size,v=0;v<c;v++){for(var y=v%d,m=v-y+Math.max(0,y-n),g=v-y+Math.min(d,y+n+1),S=0,I=m;I<g;I++)S+=Math.pow(h[I],2);S=i*S+o;for(I=m;I<g;I++){var b=-2*i*s*h[I]*f[v]/S;v===I&&(b+=Math.pow(S,-s)),b*=u[v],l[I]+=b}}return e.tensor4d(l,t.shape)},a.prototype.multinomial=function(t,a,n,o){p(t,"multinomial");for(var i=a?t:e.softmax(t),s=i.shape[0],d=i.shape[1],u=e.zeros([s,n],"int32"),h=this.readSync(u.dataId),f=this.readSync(i.dataId),l=0;l<s;++l){var c=l*d,v=new Float32Array(d-1);v[0]=f[c];for(var y=1;y<v.length;++y)v[y]=v[y-1]+f[c+y];for(var m=r.alea(o.toString()),g=l*n,S=0;S<n;++S){var I=m();h[g+S]=v.length;for(var b=0;b<v.length;b++)if(I<v[b]){h[g+S]=b;break}}}return u},a.prototype.oneHot=function(t,r,a,n){p(t,"oneHot");var o=new Float32Array(t.size*r);o.fill(n);for(var i=this.readSync(t.dataId),s=0;s<t.size;++s)i[s]>=0&&i[s]<r&&(o[s*r+i[s]]=a);return e.tensor2d(o,[t.size,r],"int32")},a.prototype.nonMaxSuppression=function(t,e,r,a,n){p(t,"nonMaxSuppression");var o=this.readSync(t.dataId),i=this.readSync(e.dataId);return f(o,i,r,a,n)},a.prototype.fft=function(t){return this.fftBatch(t,!1)},a.prototype.ifft=function(t){return this.fftBatch(t,!0)},a.prototype.fftBatch=function(t,r){for(var a=t.shape[0],n=t.shape[1],o=e.buffer(t.shape,"float32"),i=e.buffer(t.shape,"float32"),s=e.real(t).as2D(a,n),d=e.imag(t).as2D(a,n),p=0;p<a;p++)for(var u=s.slice([p,0],[1,n]),h=d.slice([p,0],[1,n]),f=e.complex(u,h),l=this.readSync(this.fftImpl(f,r).dataId),c=0;c<n;c++){var v=e.backend_util.getComplexWithIndex(l,c);o.values[p*n+c]=v.real,i.values[p*n+c]=v.imag}return e.complex(o.toTensor(),i.toTensor()).as2D(a,n)},a.prototype.fftImpl=function(t,r){var a=t.as1D(),n=a.size;if(this.isExponentOf2(n)){var o=this.fftRadix2(a,n,r).as2D(t.shape[0],t.shape[1]);return r&&(o=e.complex(e.real(o).div(e.scalar(n)),e.imag(o).div(e.scalar(n)))),o}var i=this.readSync(t.dataId),s=this.fourierTransformByMatmul(i,n,r),d=e.backend_util.splitRealAndImagArrays(s);return e.complex(d.real,d.imag).as2D(t.shape[0],t.shape[1])},a.prototype.isExponentOf2=function(t){return 0==(t&t-1)},a.prototype.fftRadix2=function(t,r,a){if(1===r)return t;var n=this.readSync(t.dataId),o=r/2,i=e.backend_util.complexWithEvenIndex(n),s=e.complex(i.real,i.imag).as1D(),d=e.backend_util.complexWithOddIndex(n),p=e.complex(d.real,d.imag).as1D();s=this.fftRadix2(s,o,a),p=this.fftRadix2(p,o,a);var u=e.backend_util.exponents(r,a),h=e.complex(u.real,u.imag).mul(p),f=s.add(h),l=s.sub(h),c=e.real(f).concat(e.real(l)),v=e.imag(f).concat(e.imag(l));return e.complex(c,v).as1D()},a.prototype.fourierTransformByMatmul=function(t,r,a){for(var n=new Float32Array(2*r),o=0;o<r;o++){for(var i=0,s=0,d=0;d<r;d++){var p=e.backend_util.exponent(o*d,r,a),u=e.backend_util.getComplexWithIndex(t,d);i+=u.real*p.real-u.imag*p.imag,s+=u.real*p.imag+u.imag*p.real}a&&(i/=r,s/=r),e.backend_util.assignToTypedArray(n,i,s,o)}return n},a.prototype.depthToSpace=function(t,r,a){e.util.assert("NHWC"===a,(function(){return"Only NHWC dataFormat supported on CPU for depthToSpace. Got "+a})),e.util.assert(r>1,(function(){return"blockSize should be > 1 for depthToSpace, but was: "+r}));for(var n=t.shape[0],o=t.shape[1],i=t.shape[2],s=t.shape[3],d=o*r,p=i*r,u=s/(r*r),h=this.readSync(t.dataId),f=new Float32Array(n*d*p*u),l=0,c=0;c<n;++c)for(var v=0;v<d;++v)for(var y=Math.floor(v/r),m=v%r,g=0;g<p;++g)for(var S=Math.floor(g/r),I=(m*r+g%r)*u,b=0;b<u;++b){var k=b+I+s*(S+i*(y+o*c));f[l++]=h[k]}return e.tensor4d(f,[n,d,p,u])},a.prototype.broadcastedBinaryOp=function(t,r,a,n){var o=e.backend_util.assertAndGetBroadcastShape(t.shape,r.shape),i=e.buffer(o,a),s=this.readSync(t.dataId),d=this.readSync(r.dataId),p=e.backend_util.getBroadcastDims(t.shape,o),u=e.backend_util.getBroadcastDims(r.shape,o),h=i.values;if(p.length+u.length===0)for(var f=0;f<h.length;++f)h[f]=n(s[f%s.length],d[f%d.length]);else{var l=this.bufferSync(t),c=this.bufferSync(r),v=function(e){var a=i.indexToLoc(e),o=a.slice(-t.rank);p.forEach((function(t){return o[t]=0}));var f=l.locToIndex(o),v=a.slice(-r.rank);u.forEach((function(t){return v[t]=0}));var y=c.locToIndex(v);h[e]=n(s[f],d[y])};for(f=0;f<h.length;++f)v(f)}return i.toTensor()},a.prototype.broadcastedBinaryComplexOp=function(t,r,a){var n=e.backend_util.assertAndGetBroadcastShape(t.shape,r.shape),o=e.buffer(n,"float32"),i=e.buffer(n,"float32"),s=this.readSync(t.dataId),d=this.readSync(r.dataId),p=e.backend_util.getBroadcastDims(t.shape,n),u=e.backend_util.getBroadcastDims(r.shape,n),h=o.values,f=i.values;if(p.length+u.length===0)for(var l=0;l<h.length;l++){var c=l%s.length,v=l%d.length,y=a(s[2*c],s[2*c+1],d[2*v],d[2*v+1]);h[l]=y.real,f[l]=y.imag}else{var m=this.bufferSync(this.data.get(t.dataId).complexTensors.real),g=this.bufferSync(this.data.get(r.dataId).complexTensors.real),S=function(e){var n=o.indexToLoc(e),i=n.slice(-t.rank);p.forEach((function(t){return i[t]=0}));var l=m.locToIndex(i),c=n.slice(-r.rank);u.forEach((function(t){return c[t]=0}));var v=g.locToIndex(c),y=a(s[2*l],s[2*l+1],d[2*v],d[2*v+1]);h[e]=y.real,f[e]=y.imag};for(l=0;l<h.length;l++)S(l)}return this.complex(o.toTensor(),i.toTensor())},a.prototype.split=function(t,e,r){return l(t,e,r)},a.prototype.dispose=function(){},a.prototype.floatPrecision=function(){return 32},a.prototype.epsilon=function(){return t.prototype.epsilon.call(this)},a.prototype.cropAndResize=function(t,r,a,n,o,i){for(var s=t.shape,d=s[0],p=s[1],u=s[2],h=s[3],f=r.shape[0],l=n[0],c=n[1],v=e.buffer([f,l,c,h],"float32"),y=this.readSync(r.dataId),m=this.readSync(a.dataId),g=this.readSync(t.dataId),S=t.strides,I=v.strides,b=0;b<f;b++){var k=4*b,M=y[k],x=y[k+1],A=y[k+2],F=y[k+3],D=m[b];if(!(D>=d))for(var w=l>1?(A-M)*(p-1)/(l-1):0,T=c>1?(F-x)*(u-1)/(c-1):0,N=0;N<l;N++){var z=l>1?M*(p-1)+N*w:.5*(M+A)*(p-1);if(z<0||z>p-1)for(var W=0;W<c;W++)for(var _=0;_<h;_++){var H=_+W*I[2]+N*I[1]+b*I[0];v.values[H]=i}else if("bilinear"===o){var O=Math.floor(z),C=Math.ceil(z),B=z-O;for(W=0;W<c;W++){if((j=c>1?x*(u-1)+W*T:.5*(x+F)*(u-1))<0||j>u-1)for(_=0;_<h;_++){H=_+W*I[2]+N*I[1]+b*I[0];v.values[H]=i}else{var E=Math.floor(j),P=Math.ceil(j),R=j-E;for(_=0;_<h;_++){var q=g[H=_+E*S[2]+O*S[1]+D*S[0]],L=g[H=_+P*S[2]+O*S[1]+D*S[0]],U=g[H=_+E*S[2]+C*S[1]+D*S[0]],G=q+(L-q)*R,V=U+(g[H=_+P*S[2]+C*S[1]+D*S[0]]-U)*R;H=_+W*I[2]+N*I[1]+b*I[0],v.values[H]=G+(V-G)*B}}}}else for(W=0;W<c;++W){var j;if((j=c>1?x*(u-1)+W*T:.5*(x+F)*(u-1))<0||j>u-1)for(_=0;_<h;_++){H=_+W*I[2]+N*I[1]+b*I[0];v.values[H]=i}else{var Y=Math.round(j),K=Math.round(z);for(_=0;_<h;_++){var Z=_+Y*S[2]+K*S[1]+D*S[0],J=_+W*I[2]+N*I[1]+b*I[0];v.values[J]=g[Z]}}}}}return v.toTensor()},a.prototype.sparseToDense=function(t,r,a,n){var o=e.backend_util.calculateShapes(r,t,a),i=o.sliceRank,s=o.numUpdates,d=o.sliceSize,p=o.strides,u=o.outputSize;return this.scatter(t,r,a,u,d,s,i,p,n,!1)},a.prototype.gatherND=function(t,r){var a=r.shape,n=a[a.length-1],o=e.backend_util.prepareAndValidate(t,r),i=o[0],s=o[1],d=o[2],p=o[3];if(0===s)return e.tensor([],i,t.dtype);for(var u=new e.TensorBuffer([s,d],t.dtype),h=this.readSync(r.dataId),f=this.readSync(t.dataId),l=0;l<s;l++){for(var c=[],v=0,y=0;y<n;y++){var m=h[l*n+y];v+=m*p[y],c.push(m)}if(v<0||v>=t.size/d)throw new Error("Invalid indices: "+c+" does not index into "+t.shape);for(var g=0;g<d;g++)u.values[l*d+g]=f[v*d+g]}return u.toTensor().reshape(i)},a.prototype.scatterND=function(t,r,a){var n=e.backend_util.calculateShapes(r,t,a),o=n.sliceRank,i=n.numUpdates,s=n.sliceSize,d=n.strides,p=n.outputSize,u=e.scalar(0);return this.scatter(t,r,a,p,s,i,o,d,u,!0)},a.prototype.fill=function(t,r,a){a=a||e.util.inferDtype(r);var n=e.util.getArrayFromDType(a,e.util.sizeFromShape(t));return n.fill(r),e.engine().makeTensor(n,t,a,this)},a.prototype.onesLike=function(t){if("string"===t.dtype)throw new Error("onesLike is not supported for string tensors");return this.fill(t.shape,1,t.dtype)},a.prototype.zerosLike=function(t){var r=e.util.getArrayFromDType(t.dtype,e.util.sizeFromShape(t.shape));return this.makeOutput(r,t.shape,t.dtype)},a.prototype.linspace=function(t,r,a){return e.backend_util.linspaceImpl(t,r,a)},a.prototype.scatter=function(t,r,a,n,o,i,s,d,p,u){var h=[n/o,o],f=this.readSync(t.dataId),l=this.readSync(r.dataId);if(0===n)return e.tensor([],a,r.dtype);var c=new e.TensorBuffer(h,r.dtype);c.values.fill(this.readSync(p.dataId)[0]);for(var v=0;v<i;v++){for(var y=[],m=0,g=0;g<s;g++){var S=f[v*s+g];y.push(S),m+=S*d[g]}if(m<0||m>=n/o)throw new Error("Invalid indices: "+y+" does not index into "+a);for(var I=0;I<o;I++)u?c.values[m*o+I]+=l[v*o+I]:c.values[m*o+I]=0===r.rank?l[0]:l[v*o+I]}return c.toTensor().reshape(a)},a}(e.KernelBackend),S={kernelName:e.Dilation2D,backendName:"cpu",kernelFunc:function(t){for(var r=t.inputs,a=t.backend,n=t.attrs,o=r,i=o.x,s=o.filter,d=n,p=d.strides,u=d.pad,h=d.dilations,f=a,l=e.util.toNestedArray(i.shape,f.data.get(i.dataId).values),c=e.util.toNestedArray(s.shape,f.data.get(s.dataId).values),v=e.backend_util.computeDilation2DInfo(i.shape,s.shape,p,u,"NHWC",h),y=v.batchSize,m=v.inHeight,g=v.inWidth,S=v.inChannels,I=v.outHeight,b=v.outWidth,k=v.padInfo,M=v.strideHeight,x=v.strideWidth,A=v.filterHeight,F=v.filterWidth,D=v.dilationHeight,w=v.dilationWidth,T=v.outShape,N=e.util.makeZerosNestedTypedArray(T,i.dtype),z=0;z<y;++z)for(var W=0;W<I;++W)for(var _=W*M-k.top,H=0;H<b;++H)for(var O=H*x-k.left,C=0;C<S;++C){for(var B=Number.MIN_SAFE_INTEGER,E=0;E<A;++E){var P=_+E*D;if(P>=0&&P<m)for(var R=0;R<F;++R){var q=O+R*w;if(q>=0&&q<g){var L=l[z][P][q][C]+c[E][R][C];L>B&&(B=L)}}}N[z][W][H][C]=B}return{dataId:f.write(e.util.toTypedArray(N,i.dtype),T,i.dtype),shape:T,dtype:i.dtype}}},I={kernelName:e.Dilation2DBackpropFilter,backendName:"cpu",kernelFunc:function(t){var r=t.inputs,a=t.backend,n=t.attrs,o=r,i=o.x,s=o.filter,d=o.dy,p=n,u=p.strides,h=p.pad,f=p.dilations,l=a,c=e.util.toNestedArray(i.shape,l.data.get(i.dataId).values),v=e.util.toNestedArray(s.shape,l.data.get(s.dataId).values),y=e.backend_util.computeDilation2DInfo(i.shape,s.shape,u,h,"NHWC",f),m=y.batchSize,g=y.inHeight,S=y.inWidth,I=y.inChannels,b=y.outHeight,k=y.outWidth,M=y.padInfo,x=y.strideHeight,A=y.strideWidth,F=y.filterHeight,D=y.filterWidth,w=y.dilationHeight,T=y.dilationWidth,N=y.outShape;e.util.assert(d.rank===N.length,(function(){return"Error in "+e.Dilation2DBackpropFilter+", dy must have the same rank as output "+N.length+", but got "+d.rank}));for(var z=e.util.toNestedArray(N,l.data.get(d.dataId).values),W=e.util.makeZerosNestedTypedArray(s.shape,s.dtype),_=0;_<m;++_)for(var H=0;H<b;++H)for(var O=H*x-M.top,C=0;C<k;++C)for(var B=C*A-M.left,E=0;E<I;++E){for(var P=Number.MIN_SAFE_INTEGER,R=0,q=0,L=0;L<F;++L){var U=O+L*w;if(U>=0&&U<g)for(var G=0;G<D;++G){var V=B+G*T;if(V>=0&&V<S){var j=c[_][U][V][E]+v[L][G][E];j>P&&(P=j,R=L,q=G)}}}W[R][q][E]+=z[_][H][C][E]}return{dataId:l.write(e.util.toTypedArray(W,i.dtype),s.shape,s.dtype),shape:s.shape,dtype:s.dtype}}},b={kernelName:e.Dilation2DBackpropInput,backendName:"cpu",kernelFunc:function(t){var r=t.inputs,a=t.backend,n=t.attrs,o=r,i=o.x,s=o.filter,d=o.dy,p=n,u=p.strides,h=p.pad,f=p.dilations,l=a,c=e.util.toNestedArray(i.shape,l.data.get(i.dataId).values),v=e.util.toNestedArray(s.shape,l.data.get(s.dataId).values),y=e.backend_util.computeDilation2DInfo(i.shape,s.shape,u,h,"NHWC",f),m=y.batchSize,g=y.inHeight,S=y.inWidth,I=y.inChannels,b=y.outHeight,k=y.outWidth,M=y.padInfo,x=y.strideHeight,A=y.strideWidth,F=y.filterHeight,D=y.filterWidth,w=y.dilationHeight,T=y.dilationWidth,N=y.outShape;e.util.assert(d.rank===N.length,(function(){return"Error in "+e.Dilation2DBackpropInput+", dy must have the same rank as output "+N.length+", but got "+d.rank}));for(var z=e.util.toNestedArray(N,l.data.get(d.dataId).values),W=e.util.makeZerosNestedTypedArray(i.shape,i.dtype),_=0;_<m;++_)for(var H=0;H<b;++H)for(var O=H*x-M.top,C=0;C<k;++C)for(var B=C*A-M.left,E=0;E<I;++E){for(var P=Number.MIN_SAFE_INTEGER,R=O<0?0:O,q=B<0?0:B,L=0;L<F;++L){var U=O+L*w;if(U>=0&&U<g)for(var G=0;G<D;++G){var V=B+G*T;if(V>=0&&V<S){var j=c[_][U][V][E]+v[L][G][E];j>P&&(P=j,R=U,q=V)}}}W[_][R][q][E]+=z[_][H][C][E]}return{dataId:l.write(e.util.toTypedArray(W,i.dtype),i.shape,i.dtype),shape:i.shape,dtype:i.dtype}}};function k(t,e){return{kernelName:t,backendName:"cpu",kernelFunc:function(r){var a=r.inputs,n=r.backend,o=a,i=o.a,s=o.b,d=n;p([i,s],t);var u=d.data.get(i.dataId).values,h=d.data.get(s.dataId).values,f=e(i.shape,s.shape,u,h,i.dtype),l=f[0],c=f[1];return{dataId:d.write(l,c,i.dtype),shape:c,dtype:i.dtype}}}}function M(t){return function(r,a,n,o,i){var s=e.backend_util.assertAndGetBroadcastShape(r,a),d=s.length,p=e.util.computeStrides(s),u=e.util.sizeFromShape(s),h=e.util.getTypedArrayFromDType(i,u),f=r.length,l=a.length,c=e.util.computeStrides(r),v=e.util.computeStrides(a),y=e.backend_util.getBroadcastDims(r,s),m=e.backend_util.getBroadcastDims(a,s);if(y.length+m.length===0)for(var g=0;g<h.length;++g)h[g]=t(n[g%n.length],o[g%o.length]);else{var S=function(r){var a=e.util.indexToLoc(r,d,p),i=a.slice(-f);y.forEach((function(t){return i[t]=0}));var s=e.util.locToIndex(i,f,c),u=a.slice(-l);m.forEach((function(t){return u[t]=0}));var g=e.util.locToIndex(u,l,v);h[r]=t(n[s],o[g])};for(g=0;g<h.length;++g)S(g)}return[h,s]}}var x=M((function(t,e){return t/e})),A=k(e.Div,x),F={kernelName:e.Max,backendName:"cpu",kernelFunc:function(t){var r=t.inputs,o=t.attrs,i=t.backend,s=r.x,d=o,u=d.reductionIndices,h=d.keepDims,f=i,l=s.shape,c=l.length,v=e.util.parseAxisParam(u,l),y=v,m=e.backend_util.getAxesPermutation(y,c),g=f.data.get(s.dataId).values;if(null!=m){for(var S=new Array(c),I=0;I<S.length;I++)S[I]=l[m[I]];g=n(g,l,s.dtype,m,S),y=e.backend_util.getInnerMostAxes(y.length,c),l=S}p(s,"max"),e.backend_util.assertAxesAreInnerMostDims("max",y,c);var b=e.backend_util.computeOutAndReduceShapes(l,y),k=b[0],M=b[1],x=a(g,e.util.sizeFromShape(M),k,s.dtype),A=f.write(x,k,s.dtype),F=k;h&&(F=S=e.backend_util.expandShapeToKeepDim(k,v));return{dataId:A,shape:F,dtype:s.dtype}}};for(var D={kernelName:e.MaxPoolWithArgmax,backendName:"cpu",kernelFunc:function(t){var r=t.inputs,a=t.attrs,n=t.backend,o=r.x,i=a,s=i.filterSize,d=i.strides,f=i.pad,l=i.includeBatchInIndex,c=n;p(o,"MaxPoolWithArgmax");var v=c.data.get(o.dataId).values,y=e.backend_util.computePool2DInfo(o.shape,s,d,[1,1],f),m=function(t,r,a,n,o){var i=u(t,0,a,e.util.computeStrides(r),o,"max"),s=h(t,r,a,o,!0,n);return[i.values,s.values]}(v,o.shape,o.dtype,l,y),g=m[0],S=m[1],I=c.write(g,y.outShape,o.dtype),b=c.write(S,y.outShape,o.dtype);return[{dataId:I,shape:y.outShape,dtype:o.dtype},{dataId:b,shape:y.outShape,dtype:"int32"}]}},w=e.kernel_impls.nonMaxSuppressionV4Impl,T={kernelName:e.NonMaxSuppressionV4,backendName:"cpu",kernelFunc:function(t){var e=t.inputs,r=t.backend,a=t.attrs,n=e,o=n.boxes,i=n.scores,s=a,d=s.maxOutputSize,u=s.iouThreshold,h=s.scoreThreshold,f=s.padToMaxOutputSize,l=r;p(o,"NonMaxSuppressionPadded");var c=l.data.get(o.dataId).values,v=l.data.get(i.dataId).values,y=w(c,v,d,u,h,f);return[y.selectedIndices,y.validOutputs]}},N=e.kernel_impls.nonMaxSuppressionV5Impl,z={kernelName:e.NonMaxSuppressionV5,backendName:"cpu",kernelFunc:function(t){var e=t.inputs,r=t.backend,a=t.attrs,n=e,o=n.boxes,i=n.scores,s=a,d=s.maxOutputSize,u=s.iouThreshold,h=s.scoreThreshold,f=s.softNmsSigma,l=r;p(o,"NonMaxSuppressionWithScore");var c=l.data.get(o.dataId).values,v=l.data.get(i.dataId).values,y=N(c,v,d,u,h,f);return[y.selectedIndices,y.selectedScores]}},W={kernelName:e.RotateWithOffset,backendName:"cpu",kernelFunc:function(t){for(var r=t.inputs,a=t.attrs,n=t.backend,o=r.image,i=a,s=i.radians,d=i.fillValue,p=i.center,u=n,h=e.util.getTypedArrayFromDType(o.dtype,e.util.sizeFromShape(o.shape)),f=o.shape,l=f[0],c=f[1],v=f[2],y=f[3],m=e.backend_util.getImageCenter(p,c,v),g=m[0],S=m[1],I=Math.sin(s),b=Math.cos(s),k=u.data.get(o.dataId).values,M=0;M<l;M++)for(var x=M*v*c*y,A=0;A<c;A++)for(var F=A*(v*y),D=0;D<v;D++)for(var w=D*y,T=0;T<y;T++){var N=[l,A,D,T],z=N[2],W=N[1],_=(z-g)*b-(W-S)*I,H=(z-g)*I+(W-S)*b;_=Math.round(_+g),H=Math.round(H+S);var O=d;if("number"!=typeof d&&(O=3===T?255:d[T]),_>=0&&_<v&&H>=0&&H<c)O=k[x+H*(v*y)+_*y+T];h[x+F+w+T]=O}return{dataId:u.write(h,o.shape,o.dtype),shape:o.shape,dtype:o.dtype}}},_={kernelName:e.Square,backendName:"cpu",kernelFunc:function(t){var e=t.inputs,r=t.backend,a=e.x,n=r;p(a,"square");for(var o=n.data.get(a.dataId).values,i=new Float32Array(o.length),s=0;s<o.length;++s){var d=o[s];i[s]=d*d}return{dataId:n.write(i,a.shape,a.dtype),shape:a.shape,dtype:a.dtype}}},H=M((function(t,e){var r=t-e;return r*r})),O=0,C=[S,b,I,A,D,F,T,z,W,_,k(e.SquaredDifference,H),{kernelName:e.Transpose,backendName:"cpu",kernelFunc:function(t){var e=t.inputs,r=t.attrs,a=t.backend,o=e.x,i=r.perm,s=a;p(o,"transpose");for(var d=o.shape.length,u=new Array(d),h=0;h<u.length;h++)u[h]=o.shape[i[h]];var f=n(s.data.get(o.dataId).values,o.shape,o.dtype,i,u);return{dataId:s.write(f,u,o.dtype),shape:u,dtype:o.dtype}}}];O<C.length;O++){var B=C[O];e.registerKernel(B)}e.registerBackend("cpu",(function(){return new g}),1),t.MathBackendCPU=g,t.shared=o,t.version_cpu="2.1.0",Object.defineProperty(t,"__esModule",{value:!0})}));
//# sourceMappingURL=tf-backend-cpu.min.js.map
